
/* ****
bxadd 1.0.5 - A program to add a file to a box archive with one command line
Copyright (C) 1996  Adam Ophir Shapira

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


To contact the author by snail mail,
send mail to the following address:

    Adam Ophir Shapira
    Chief Service Person
    Ultra-Flamin' Cool Computer Consulting
    114 Montana Ave.
    Oak Ridge, TN 37830


To contact the author by E-mail, send
mail to the following address:

    docwho@usit.net
**** */

#include <stdio.h>


FILE *omicron;
FILE *omicran;


main(argc,argv,environ)
	int argc;
	char **argv;
	char **environ;
{
  char a; /* Character prior to the one currently being processed. */
  char b; /* Character of file that is currently being processed. */

  if ((argc < 4) || (argc > 5)) /* If there is not the right number of
      arguments: */
    {

  /* Explain to the user that the usage is:
     <program-name> [boxfile] [generic-directory] [source file] */

      fprintf ( stderr, "%s usage: %s", argv[0], argv[0] );
      fprintf ( stderr, " [boxfile] [generic-directory]" );
      fprintf ( stderr, " [source file] ([mode])\n" );
      return;
    }

  omicron = fopen ( argv[3], "r" ); /* Open the source file. */
  if ( omicron == NULL ) /* If opening it fails ... */
    {
      fprintf ( stderr, "%s: %s: can not read file ", argv[0], argv[1] );
      fprintf ( stderr, "%s:\n", argv[3] );
      /* ... inform the user that it couldn't read file ... */

      return; /* ... and exit. */
    }

  omicran = fopen ( argv[1], "a" ); /* Prepare to append to .box archive. */
  if ( omicran == NULL ) /* If that fails ... */
    {
      fprintf ( stderr, "%s: unable to write to the ", argv[0] );
      fprintf ( stderr, "file \"%s\".\n", argv[1] );
      /* ... inform the user that it couldn't write onto the file ... */

      fclose ( omicron ); /* ... close the source file ... */
      return; /* ... and exit. */
    }

  fprintf ( omicran, "f %s/%s\n", argv[2], argv[3] );
  /* Mark the file's beginning and name in the .box archive. */

  a = '\n';
  /* Pretend that you just processed a newline character, because the
  first character of the file is also the first character of it's line. */

  b = fgetc(omicron);
  /* Get the first character from the source file. */

  while ( !feof(omicron) ) /* until the whole file has been added: */
    {
      if ( a == '\n' ) fprintf ( omicran, "--%c", b );
      /* If this is the first character of a line, write a dash and
         a blanks-space before actually beginning to write the contents
         of the line to the file. */

      else fprintf ( omicran, "%c", b );
      /* On the other hand, if this isn't the first character of the
         current line, then just go ahead and write this character. */

      /* Begin getting ready for the next round. */
      a = b; /* Set previous-character value for the next round. */
      b = fgetc(omicron); /* Get next source-file character. */
    }

  if ( a == '\n' ) fprintf ( omicran, "close\n" );
  else fprintf ( omicran, "\nclose\n" );
  /* Mark in the archive the end of current source file. */

  if ( argc < 5 )
      fprintf ( omicran, "s chmod 644 %s/%s\n", argv[2], argv[3] );
  else
      fprintf ( omicran, "s chmod %s %s/%s\n", argv[4], argv[2], argv[3] );
  /* Make sure that nobody other than the user who unpacks the
     .box archive can modify this file. */

  fflush(omicran);
  fclose ( omicron );
  fclose ( omicran );
  /* Close both the source file and the .box archive. */
}


