/* ****
cool-language-p.c - by Adam Ophir Shapira
Copyright (C) 2001 Techno-Info Comprehensive Solutions

This software is licensed under the terms of the GNU General Public
License version 2.0 of the Free Software Foundation (http://www.gnu.org)
with NO WARRANTY, even the implied waranty of merchantability, or
usability for a particular purpose.

To contact the author of this program, visit the software web-site
at:  http://boxenv.com
**** */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define BUFOR_SIZ 5000

char inbuf[BUFOR_SIZ];

int in_a_parag = 0;
int midl_parag;
int last_fontexp;
int in_a_font;

char last_crwas;

int crocenter;

char *purify ( char *rg_a );
void dueprocess ( char *rg_a );
void esca_parag ( void );
void start_parag ( char *rg_a );
void start_c_parag ( char *rg_a );
void puglin ( char *rg_a );
void opn_puglin ( char *rg_a );
void pugchar ( char rg_a );
void myob_gets ( char *rg_a );
void dupi_m ( char *rg_a );
void dupi_c ( char *rg_a );
char *decolon ( char *rg_a );
int samestrg ( char *rg_a, char *rg_b );

char dflext[] = "html";
char *ourext;

int flag_split_url;

int main(int argc, char **argv, char **environ)
{
  char *a;
  int b;
  int c;

  ourext = dflext;

  flag_split_url = 0;

  for ( b = 1; b < argc; b++ )
  {
    c = b;
    if ( samestrg(argv[b],"+split_url") > 5 ) flag_split_url = 10;
    if ( samestrg(argv[b],"-split_url") > 5 ) flag_split_url = 0;
    if ( samestrg(argv[b],"-ext") > 5 )
    {
      c++;
      if ( argv[c] != ((char *)NULL) ) ourext = argv[c];
    }
    b = c;
  }

  printf("<html>\n");
  printf("<body\n");
  printf("bgcolor = \"#FFFFFF\"\n");
  printf("text = \"#000000\"\n");
  printf("link = \"#FF0000\"\n");
  printf("vlink = \"#0000FF\"\n");
  printf("alink = \"#00FF00\">\n");
  /* printf("<div align = \"center\">\n"); */

  crocenter = 0;

  myob_gets(inbuf);
  while ( !feof(stdin) )
  {
    a = purify(inbuf);
    dueprocess(a);

    myob_gets(inbuf);
  }
  esca_parag();

  /* printf("</div></body></html>\n"); */

  fflush(stdout);
  return 0;
}

char *purify ( char *rg_a )
{
  char *a;
  char *b;
  char c;

  a = rg_a;
  b = a;
  c = *a;

  while ( *a != '\0' )
  {
    c = *a;
    a++;
    if ( isgraph(c) ) b = a;
  }
  *b = '\0';

  a = rg_a;
  while ( ( !(isgraph(*a)) ) && ( (*a) != '\0' ) )
  {
    a++;
  }
  return a;
}

void dueprocess ( char *rg_a )
{
  char *a;
  char b;

  b = *rg_a;
  a = rg_a;
  a++;

  if ( b == 'p' ) start_parag(a);
  if ( b == 'c' ) start_c_parag(a);

  if ( b == 'm' ) dupi_m(a);
  if ( b == ':' ) dupi_c(a);
  if ( b == '$' ) { esca_parag(); fflush(stdout); system(a); }

  if ( b == '/' )
  {
    if ( midl_parag > 5 ) printf("\n<br>");
    dueprocess(a);
  }

  if ( b == '-' ) 
  {
    if ( midl_parag > 5 ) printf("\n");
    last_crwas = ' ';
    puglin(a);
    midl_parag = 10;
  }
  
  if ( b == 'l' )
  {
    if ( midl_parag > 5 ) printf("\n");
    printf ( "<a href =\n\"");
    last_crwas = ' ';
    puglin(a);
    printf ( "\"\n>" );
    last_crwas = ' ';
    if ( flag_split_url > 5 ) opn_puglin(a); else puglin(a);
    printf ( "</a>" );
    midl_parag = 10;
  }

  if ( b == 'i' )
  {
    if ( midl_parag > 5 ) printf("\n");
    printf ( "<a href =\n\"");
    last_crwas = ' ';
    puglin(a);
    printf ( ".%s\"\n>", ourext );
    last_crwas = ' ';
    puglin(a);
    printf ( "</a>" );
    midl_parag = 10;
  }

  if ( b == 'e' )
  {
    if ( midl_parag > 5 ) printf("\n");
    printf ( "<a href =\n\"mailto:");
    last_crwas = ' ';
    puglin(a);
    printf ( "\"\n>" );
    last_crwas = ' ';
    puglin(a);
    printf ( "</a>" );
    midl_parag = 10;
  }

  if ( b == '*' )
  {
    if ( midl_parag > 5 ) printf("\n<br>");
    last_crwas = ' ';
    puglin(a);
    midl_parag = 10;
  }

  if ( b == 'b' )
  {
    printf("<b>");
    dueprocess(a);
    printf("</b>");
  }
}

void start_parag ( char *rg_a )
{
  int a;

  esca_parag();
  a = atoi(rg_a);
  printf ( "\n<p>\n" );
  in_a_font = 0;
  if ( a >= 1 )
  {
    printf("<font size = \"+%d\">\n",a);
    in_a_font = 10;
  }
  last_fontexp = a;
  in_a_parag = 10;
  midl_parag = 0;
}

void start_democode ( char *rg_a )
{
  int a;

  esca_parag();
  a = atoi(rg_a);
  printf ( "\n<br><table border = 0 width = \"80%%\"><tr><td>\n" );
  in_a_font = 0;
  if ( a >= 1 )
  {
    printf("<font size = \"+%d\">\n",a);
    in_a_font = 10;
  }
  last_fontexp = a;
  in_a_parag = 10;
  midl_parag = 0;
}

void start_c_parag ( char *rg_a )
{
  int a;

  esca_parag();
  a = atoi(rg_a);

  printf("<div align = \"center\">\n");
  crocenter = 10;

  printf ( "\n<p>\n");
  in_a_font = 0;
  if ( a >= 1 )
  {
    printf("<font size = \"+%d\">\n",a);
    in_a_font = 10;
  }
  last_fontexp = a;
  in_a_parag = 10;
  midl_parag = 0;
}

void esca_parag ( void )
{
  if ( in_a_parag < 5 ) return;
  if ( in_a_font > 5 ) printf("</font>\n");
  printf("</p>\n");
  if ( crocenter > 5 ) { printf("</div>\n"); }
  crocenter = 0;
  in_a_parag = (0);
}

void puglin ( char *rg_a )
{
  char *a;

  a = rg_a;
  if ( a == ((char *)NULL) ) return;
  while ( (*a) != '\0' )
  {
    /* printf("&#%d;",((int)(*a))); */
    pugchar(*a);
    a++;
  }
}

void opn_puglin ( char *rg_a )
{
  char *a;
  char b;
  char c;

  b = 'x';
  a = rg_a;
  if ( a == ((char *)NULL) ) return;
  while ( (*a) != '\0' )
  {
    /* printf("&#%d;",((int)(*a))); */
    c = *a;

    /* This next block of code is to ensure that a URL */
    /* will generally carry over to the next line if necessary. */
    if ( b == '/' )
    { if ( c != '/' ) { if ( isgraph(c) ) putchar('\n'); } }

    pugchar(c);
    b = c; a++;
  }
}

void pugchar ( char rg_a )
{
  static int st_a = 0;
  char a;

  a = last_crwas;
  last_crwas = rg_a;

  if ( rg_a == ' ' )
  {
    if ( a == ' ' )
    {
      printf("&nbsp;");
      return;
    }
    st_a++;
    if ( st_a > 10 ) st_a = 0;
    if ( st_a == '2' )
    {
      putchar('\n');
      return;
    }
    putchar(' ');
    return;
  }

  if ( ( rg_a >= 'A' ) && ( rg_a <= 'Z' ) )
  {
    putchar(rg_a);
    return;
  }

  if ( ( rg_a >= 'a' ) && ( rg_a <= 'z' ) )
  {
    putchar(rg_a);
    return;
  }

  if ( ( rg_a >= '0' ) && ( rg_a <= '9' ) )
  {
    putchar(rg_a);
    return;
  }

  if ( rg_a == '<' ) { printf("&lt;"); return; }
  if ( rg_a == '>' ) { printf("&gt;"); return; }

  if ( rg_a == ':' ) { putchar(rg_a); return; }
  if ( rg_a == '.' ) { putchar(rg_a); return; }
  if ( rg_a == ',' ) { putchar(rg_a); return; }
  if ( rg_a == '/' ) { putchar(rg_a); return; }
  if ( rg_a == '-' ) { putchar(rg_a); return; }
  if ( rg_a == '@' ) { putchar(rg_a); return; }
  if ( rg_a == '\?' ) { putchar(rg_a); return; }
  if ( rg_a == '(' ) { putchar(rg_a); return; }
  if ( rg_a == ')' ) { putchar(rg_a); return; }
  if ( rg_a == '{' ) { putchar(rg_a); return; }
  if ( rg_a == '}' ) { putchar(rg_a); return; }
  if ( rg_a == '[' ) { putchar(rg_a); return; }
  if ( rg_a == ']' ) { putchar(rg_a); return; }

  printf("&#%d;",((int)rg_a));
}

void myob_gets ( char *rg_a )
{
  char *a;
  char b;

  a = rg_a;

  b = fgetc(stdin);
  if ( b == '\n' ) b = '\0';
  if ( b == (char)13 ) b = '\0';
  if ( feof(stdin) ) b = '\0';

  while ( b != '\0' )
  {
    *a = b;
    a++;

    b = fgetc(stdin);
    if ( b == '\n' ) b = '\0';
    if ( b == (char)13 ) b = '\0';
    if ( feof(stdin) ) b = '\0';
  }

  *a = '\0';
}

void dupi_m ( char *rg_a )
{
  char *a;
  char b;

  a = rg_a;
  b = *a;
  a++;

  if ( b == 'g' )
  {
    printf("<img src =\n\"");
    puglin(a);
    printf("\"\n>");
    midl_parag = 10;
  }
}

void dupi_c ( char *rg_a )
{
  char *a;
  int b;
  char *c;
  char d;

  a = decolon ( rg_a );

  b = samestrg ( rg_a, "ilink" );
  if ( b > 5 )
  {
    c = decolon(a);
    printf("\n<a href =\n\"");
    puglin(a);
    printf(".%s\"\n>", ourext);
    puglin(c);
    printf("</a>");
    midl_parag = 10;
    return;
  }

  b = samestrg ( rg_a, "apnd" );
  if ( b > 5 )
  {
    puglin(a);
    midl_parag = 10;
    return;
  }

  b = samestrg ( rg_a, "sqlink" );
  if ( b > 5 )
  {
    printf("<a href =\n\"");
    d = last_crwas;
    puglin(a);
    printf("\"\n>");
    last_crwas = d;
    puglin(a);
    printf("</a>");
  }

  b = samestrg ( rg_a, "sfile" );
  if ( b > 5 )
  {
    esca_parag();
    in_a_font = 10;
    in_a_parag = 10;
    midl_parag = 0;
    printf("\n<br><table border = 1 width = \"80%%\"><tr><td>\n");
    printf("<div align = \"center\">\n");
    puglin(a);
    printf("</div>\n");
    printf("</td></tr><tr><td>\n");
    printf("<font face = \"Courier\">\n");
  }

  b = samestrg ( rg_a, "fixed" );
  if ( b > 5 )
  {
    esca_parag();
    in_a_font = 10;
    in_a_parag = 10;
    midl_parag = 0;
    printf("\n<br><table border = 0 width = \"80%%\"><tr><td>\n");
    printf("<font face = \"Courier\">\n");
  }

  b = samestrg ( rg_a, "picframe" );
  if ( b > 5 )
  {
    esca_parag();
    in_a_font = 0;
    in_a_parag = 10;
    midl_parag = 0;
    printf("\n<br><table border = 1><tr><td align = \"center\">\n");
    puglin(a);
    printf("\n</td></tr><tr><td align = \"center\">\n");
  }

  b = samestrg ( rg_a, "hline" );
  if ( b > 5 )
  {
    printf("\n<hr>\n");
  }
}

char *decolon ( char *rg_a )
{
  char *a;

  a = rg_a;

  if ( a == ((char *)NULL) ) return a;

  while ( *a != '\0' )
  {
    if ( *a == ':' )
    {
      *a = '\0';
      a++;
      return a;
    }

    a++;
  }
  return a;
}

int samestrg ( char *rg_a, char *rg_b )
{
  char *a;
  char *b;

  if ( rg_a == rg_b ) return 10;
  if ( rg_a == ((char *)NULL) ) return 0;
  if ( rg_b == ((char *)NULL) ) return 0;

  a = rg_a;
  b = rg_b;

  while ( *a == *b )
  {
    if ( *a == '\0' ) return 10;
    a++; b++;
  }
  return 0;
}










