/* ****
cool-language-split.c - by Adam Ophir Shapira
Copyright (C) 2001 Techno-Info Comprehensive Solutions

This software is licensed under the terms of the GNU General Public
License version 2.0 of the Free Software Foundation (http://www.gnu.org)
with NO WARRANTY, even the implied waranty of merchantability, or
usability for a particular purpose.

To contact the author of this program, visit the software web-site
at:  http://boxenv.com
**** */

#include <stdio.h>
#include <ctype.h>

#define BUFOR_SIZ 5000
char inbuf[BUFOR_SIZ];


FILE *alpha[3];
int beta;

void myob_gets ( char *rg_a );

int main(int argc, char **argv, char **environ)
{
  FILE *a;
  int b;
  char *c;

  if ( argc < 3 )
  {
    fprintf(stderr,"\n%s: usage: %s ",argv[0],argv[0]);
    fprintf(stderr,"{output-a} {output-b} < {input}\n\n");
    fflush(stderr);
    return 2;
  }

  a = fopen(argv[1],"w");
  if ( a == ((FILE *)NULL) ) return 0;

  alpha[0] = a; alpha[1] = a;

  a = fopen(argv[2],"w");
  if ( a == ((FILE *)NULL) )
  {
    a = alpha[0];
    fclose(a);
    return 3;
  }
  alpha[2] = a;

  b = 0;
  myob_gets(inbuf);
  while ( !feof(stdin) )
  {
    c = inbuf;
    while ( (!(isgraph(*c))) && ( *c != '\0' ) )
    {
      c++;
    }

    if ( *c == 'x' ) b++;
    if ( b > 2 ) b = 2;

    fprintf(alpha[b],"%s\n",inbuf);

    myob_gets(inbuf);
  }

  a = alpha[1]; fflush(a); fclose(a);
  a = alpha[2]; fflush(a); fclose(a);

  return 0;
}

void myob_gets ( char *rg_a )
{
  char *a;
  char b;

  a = rg_a;

  b = fgetc(stdin);
  if ( b == '\n' ) b = '\0';
  if ( b == (char)13 ) b = '\0';
  if ( feof(stdin) ) b = '\0';

  while ( b != '\0' )
  {
    *a = b;
    a++;

    b = fgetc(stdin);
    if ( b == '\n' ) b = '\0';
    if ( b == (char)13 ) b = '\0';
    if ( feof(stdin) ) b = '\0';
  }

  *a = '\0';
}



