
/* ****

inbox 2.0 - by Adam Ophir Shapira - Installs a ".box" package

Copyright (C) 1998  Ultra-Flamin' Cool Computer Consulting

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Adam Ophir Shapira <docwho@usit.net> is the Chief Service
Person of Ultra-Flamin' Cool Computer Consulting, at the
following address.

  Ultra-Flamin' Cool Computer Consulting
  114 Montana Ave.
  Oak Ridge, TN 37830
  U.S.A.
  Phone: (423)483-4474
  Pager: (423)631-7767


The author of this program can be reached by E-mail at:
      docwho@usit.net


The author of this program can by reached by Snail Mail at:

    Adam Ophir Shapira
    114 Montana Ave.
    Oak Ridge, TN 37830

Add "USA" at the end of the snail mail adress, if you are
mailing from outside the USA.

**** */

/* CHANGE LOGUES */

/*
CHANGE LOGUE for 1.1

December 17, 1997:
Add higch() function and it's first reference for
better processing of newline characters.

CHANGE LOGUE FOR 2.0
Add fflush() references:

*/


#include <stdio.h>
#include <stdlib.h>

#define BUFOR_SIZ 10000

char **orgv;

int stat;
FILE *dest;

void faterr ( );

void prox ( );

void qserox ( );

void erox ( );

void ogets ( );

void itopen ( );

void itclos ( );

void itput ( );

void muts ( );

void chenodira ( );

void chenodirb ( );

char higch ( ); /* FILE pt */



int action_mode = 0;
/* ****
The <action_mode> variable controls what kind of action this program
is doing.
0 = Installing a package (default)
1 = Uninstalling a package
**** */


main(argc,argv,environ)
int argc;
char *argv[];
char *environ[];
{
  FILE *a;

  orgv = argv;
  stat = 0;
  dest = NULL;
  if ( argc < 2 ) faterr ( "You must specify one (1) file name." );

  if ( argc > 2 ) { action_mode = atoi(argv[2]); }

  a = fopen ( argv[1], "r" );
  if ( a == NULL ) faterr ( "That file can\'t be opened." );
  prox ( a );
  fclose ( a );
  if ( dest != NULL )
  {
    fflush ( dest );
    fclose ( dest );
    dest = NULL;
  }
  fflush(stderr);
  fflush(stdout);
}


void faterr ( a )
char *a;
{
  fprintf ( stderr, "FATAL ERROR:\n%s\n", a );
  exit(4);
}


void prox ( a )
FILE *a;
{
  char b[BUFOR_SIZ];
  while ( !feof(a) )
  {
    ogets ( b, a );
    if ( action_mode == 0 ) { erox ( b ); }
    qserox(b);
  }
}


void qserox ( rg_a )
char *rg_a;
{
  char *lc_a; /* The "Index Finger" */
  int lc_b; /* The Applicable Action Mode (to which this line applies) */
  char lc_c; /* The Current Character */
  int lc_d; /* Does this line terminate prematurely? */

  lc_a = rg_a;

  if ( *lc_a == 'A' )
  {
    lc_a++;
    erox(lc_a);
    return;
  }

  if ( *lc_a != 'M' ) { return; }
  lc_b = 0;
  lc_a++; lc_c = *lc_a;
  while ( lc_c != ':' )
  {
    lc_d = 10;
    if ( lc_c >= '0' )
    {
      if ( lc_c <= '9' )
      {
        lc_d = 0;
        lc_b = ( ( lc_b * 10 ) + ( (int)(lc_c - '0') ) );
      }
    }

    if ( lc_d > 5 ) { return; }
    lc_a++; lc_c = *lc_a;
  }
  lc_a++;
  if ( lc_b == action_mode ) { erox(lc_a); }
}


void erox ( a )
char *a;
{
  char *b;
  b = a;
  b++;
  b++;
  if ( *a == 'p' ) muts ( b );
  if ( *a == 't' ) muts ( b ); /* t - only for inbox */
  if ( *a == 'f' ) itopen ( b );
  if ( *a == 'c' ) itclos ( );
  if ( *a == '-' ) itput ( b );
  if ( *a == 's' ) system ( b );
  if ( *a == 'i' ) system ( b ); /* i - only for inbox */
  if ( *a == 'd' ) chenodira ( b );
  if ( *a == 'e' ) chenodirb ( b );
}

void ogets ( a, b )
char *a;
FILE *b;
{
  char c;
  c = 'x';
  while ( c != '\0' )
  {
    c = higch ( b );
    *a = c;
    a++;
  }
}

void itopen ( a )
char *a;
{
  if ( dest != NULL ) { fflush(dest); fclose ( dest ); }
  dest = fopen ( a, "w" );
}


void itclos ( )
{
  if ( dest != NULL ) { fflush(dest); fclose ( dest ); }
  dest = NULL;
}


void itput ( a )
char *a;
{
  if ( dest != NULL )
  {
    if ( *(a-1) == '\0' ) fprintf ( dest, "\n" );
    else fprintf ( dest, "%s\n", a );
  }
}


void muts ( a )
char *a;
{
  if ( *(a-1) == '\0' ) putchar ( '\n' );
  else puts ( a );
}

void chenodira ( a )
char *a;
{
  int b;
  b = chdir ( a );
  if ( b == -1 )
  {
    fprintf ( stderr, "%s: Directory \"%s\" not found.\n", orgv[0], a );
    fprintf ( stderr, "%s: This is a fatal directory error.\n", orgv[0]);
    fflush(stderr);
    exit(6);
  }
}

void chenodirb ( a )
char *a;
{
  char *b;
  b = getenv ( a );
  if ( b == NULL )
  {
    fprintf ( stderr, "%s: Environment Variable \"%s\" not found.\n", orgv[0], a );
    fprintf ( stderr, "%s: This is a fatal environment error.\n", orgv[0]);
    fflush(stderr);
    exit(6);
  }
  chenodira ( b );
}

char higch ( a )
FILE *a;
{
  char b;
  b = fgetc(a);
  if ( feof(a) ) b = '\0';
  if ( b == '\n' ) b = '\0';
  if ( b == 13 ) b = '\0';
  return b;
}


