/* ****
lortune 1.0 - An alternative for the -fortune- program:
Copyright (C) 1998  Ultra-Flamin' Cool Computer Consulting
Copyright (C) 2001 Techno-Info Comprehensive Solutions

This software is licensed under the terms of the GNU General Public
License version 2.0 of the Free Software Foundation (http://www.gnu.org)
with NO WARRANTY, even the implied waranty of merchantability, or
usability for a particular purpose.

To contact the author of this program, visit the software web-site
at:  http://boxenv.com
**** */
/* main.c */

/* ****
NOTE: -lortune- is similar to -fortune- in that both
programs output a random quote from a file. However,
they are not intercompatible. First of all, there is
a completely different format for calling a -lortune-
file than there is for calling a -fortune- file. Also,
the formats of the data files for the two programs
are different.
**** */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* include "main.h" */
static int seemyworth ( void );
static long calcusiz ( void );
static int knodeter ( void );
static long getulong ( FILE *a );
static char getacre ( FILE *a );
static int prinofil ( void );
/* include "main.h" */

static int orgc;
static char **orgv;
static char **onviron;

static long sizopon;
static FILE *resofil;
static FILE *mapofil;

static long startpoin;
static long enduralen;


int main(argc,argv,environ)
int argc;
char **argv;
char **environ;
{
  orgc = argc;
  orgv = argv;
  onviron = environ;

  seemyworth();
  calcusiz();
  knodeter();
  prinofil();

  fclose(resofil);
  fclose(mapofil);
  putchar ( '\n' );
  fflush(stdout);
  exit(0);
}

static int seemyworth ( )
{
  if ( orgc < 3 )
  {
    fprintf ( stderr, "%s: usage: %s ", orgv[0], orgv[0] );
    fprintf ( stderr, "[resource] [map]\n" );
    exit(4);
  }
  resofil = fopen(orgv[1], "r");
  if ( resofil == (FILE *)NULL )
  {
    fprintf ( stderr, "%s: Can not read file: %s\n", orgv[0], orgv[1] );
    exit(5);
  }
  mapofil = fopen(orgv[2], "r");
  if ( mapofil == (FILE *)NULL )
  {
    fprintf ( stderr, "%s: Can not read file: %s\n", orgv[0], orgv[2] );
    exit(6);
  }
  return 10;
}

static long calcusiz ( )
{
  char a;
  sizopon = 0;
  a = 0;
  while (( a < (char)5 ) && ( !feof(mapofil) ))
  {
    a = fgetc(mapofil);
    sizopon++;
  }
  return sizopon;
}

static int knodeter ( )
{
  long a;
  long b;
  long c;
  long d;
  fseek(mapofil,sizopon,0);
  a = getulong(mapofil);
  srand((int)time(0));
  b = (long)rand();
  if ( a < (long)0 ) exit(7);
  c = ( b % a );
  if ( c < 0 ) c = -c;
  c++;
  b = c;
  c = ((b * sizopon) + (b * sizopon));
  fseek(mapofil,c,0);
  startpoin = getulong(mapofil);
  d = getulong(mapofil);
  enduralen = ( d - startpoin );
  return 10;
}

static long getulong ( a )
FILE *a;
{
  long b;
  long c;
  long d;
  c = 0;
  b = sizopon;
  while ( b > (long)0 )
  {
    c = ( c * (long)256 );
    d = (long)getacre(a);
    if ( d < (long)0 ) d = ( d + (long)256 );
    c = ( c + d );
    b--;
  }
  return c;
}

static char getacre ( a )
FILE *a;
{
  char b;
  b = fgetc(a);
  if ( feof(a) ) b = (char)0;
  return b;
}

static int prinofil ( )
{
  long a;
  char b;
  fseek(resofil,startpoin,0);
  a = enduralen;
  while ( a > (long)0 )
  {
    b = fgetc(resofil);
    if ( !feof(resofil) ) putchar(b);
    a--;
  }
  return 10;
}






