/* ****
mak2-lortune 1.0 - A step in preparing a -lortune- data file:
main.c
Copyright(C) 1998  Ultra-Flamin' Cool Computer Consulting
Copyright (C) 2001 Techno-Info Comprehensive Solutions

This software is licensed under the terms of the GNU General Public
License version 2.0 of the Free Software Foundation (http://www.gnu.org)
with NO WARRANTY, even the implied waranty of merchantability, or
usability for a particular purpose.

To contact the author of this program, visit the software web-site
at:  http://boxenv.com
**** */

#include <stdio.h>
#include <stdlib.h>

static int runiat ( long a, int *b, long c, FILE *d );

#define stpquoa ( ( c[0] == '\n' ) && ( c[3] == '\n' ) )
#define stpquob ( ( c[1] == '%' ) && ( c[2] == '%' ) )
#define stpquot ( stpquoa && stpquob )
#define neuquot ( ( c[1] == '\n' ) && ( c[2] == '%' ) && ( c[3] == '\n' ) )
#define grochru { c[0] = c[1]; c[1] = c[2]; c[2] = c[3]; c[3] = fgetc(d); }
#define iochru { rewind(d); c[3] = '\n'; grochru }

int main(argc,argv,environ)
int argc;
char **argv;
char **environ;
{
  long a, b;
  char c[4];
  FILE *d;
  int *e;
  long f;
  long g; /* THE SIZE OF THE BUFFER */
  long h; /* THE LAST CHARACTER NEEDED */
  long i; /* How manu quotes so far */

  if ( argc < 3 )
  {
    /* USAGE: [prognom] [filename] [bufsz] */
    exit(4);
  }
  a = atol(argv[2]);
  b = a;
  while ( b-- > 1 )
  {
    printf ( "0\n" );
  }
  printf ( "10\n" );
  fflush(stdout);

  g = a;
  b = ( a * (long)sizeof(int) );
  e = malloc(b);
  if ( e == (int *)NULL )
  {
    fprintf ( stderr, "-- exit 5\n" );
    fflush(stderr);
    exit(5);
  }

  d = fopen(argv[1], "r" );
  if ( d == (FILE *)NULL )
  {
    fprintf ( stderr, "-- exit 6\n" );
    fflush(stderr);
    exit(6);
  }

  f = (long)0;
  iochru;
  while ( !feof(d) )
  {
    if ( neuquot ) f++;
    grochru;
  }

  runiat ( f, e, g, stdout );

  fflush(stdout);

  f = (long)0;
  /* runiat ( f, e, g, stdout ); */
  h = f;
  i = (long)0;
  iochru;
  while ( !feof(d) )
  {
    f++;
    if ( neuquot )
    {
      i++;
      printf ( "# No %ld\n", i );
      runiat ( h, e, g, stdout );
      printf ( "# -\n" );
      runiat ( (f - (long)3), e, g, stdout );
      h = f;
    }
    else if ( stpquot )
    {
      h = f;
    }
    grochru;
  }

  fflush(stdout);

  fclose(d);
  return 0;
}

static int runiat ( a, b, c, d )
long a;
int *b;
long c;
FILE *d;
{
  long e;
  int *f;
  int g;
  long h, i, j;
  f = b;
  e = (long)0;
  g = 0;
  h = a;
  while ( e < c )
  {
    i = ( h % (long)256 );
    j = ( h - i );
    h = ( j / (long)256 );
    b[g] = (int)i;
    e++; g++;
  }
  while ( g > 0 )
  {
    g--;
    printf ( "%d\n", b[g] );
  }
  return 10;
}


