
/* ****
quickify.c - by Adam Ophir Shapira
Copyright (C) 2001 Techno-Info Comprehensive Solutions

This software is licensed under the terms of the GNU General Public
License version 2.0 of the Free Software Foundation (http://www.gnu.org)
with NO WARRANTY, even the implied waranty of merchantability, or
usability for a particular purpose.

To contact the author of this program, visit the software web-site
at:  http://boxenv.com
**** */

/* ****
CHANGE LOGUE:

2001-12-17 (Monday)
  Added qggx() pointer, to enable later adding alternative modes
of program:

  Added "Alternate Section" to enable the intopt() alternative
to the doprocof() function, so that Internal Data Requests can
be channeled to the <quicktrans> program:
**** */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

int dbgflag;
long dbgnum;

char *mobget ( char *rg_a );
int samestrg ( char *rg_a, char *rg_b );

void doprocof ( char *rg_a );
void intopt ( char *rg_a );
void chosys ( char *rg_a );

void (* qggx) ( char *rg_a );


int main ( int argc, char **argv, char **environ )
{
  char a[400];
  char *b;
  int c; int d;

  dbgflag = 0;
  dbgnum = ((long)0);
  qggx = doprocof;

  /* START THE "Alternate Section" */
  for ( c = 1; c < argc; c++ )
  {
    d = samestrg(argv[c],"pref");
    if ( d > 5 ) { qggx = intopt; }

    d = samestrg(argv[c],"debug");
    if ( d > 5 ) { dbgflag = 10; }
  }
  /* END THE "Alternate Section" */


  while ( !feof(stdin) )
  {
    b = mobget(a);
    qggx(b);
  }

  if ( dbgflag > 5 )
  {
    fprintf(stderr,"About to Flush Results:\n");
    fflush(stderr);
  }

  fflush(stdout);

  if ( dbgflag > 5 )
  {
    fprintf(stderr,"Results have been Flushed:\n");
    fflush(stderr);
  }

  exit(0);
  return 0;
}

char *mobget ( char *rg_a )
{
  char *a;
  char b;
  char *c;

  a = rg_a;
  b = 'x';
  while ( b != '\0' )
  {
    b = fgetc(stdin);

    if ( feof(stdin) ) b = '\0';
    if ( b == '\n' )
    {
      b = '\0';
      if ( dbgflag > 5 )
      {
        dbgnum++;
        fprintf ( stderr, "Success Line: %ld:\n", dbgnum );
        fflush(stderr);
      }
    }
    if ( b == ((char)13) ) b = '\0';

    *a = b;
    if ( b != '\0' ) { a++; }
  }

  a = rg_a; c = a; b = *a;
  while ( b != '\0' )
  {
    a++;
    if ( isgraph(b) ) { c = a; }
    b = *a;
  }

  a = rg_a; b = *a;
  if ( isgraph(b) ) { b = '\0'; }
  while ( b != '\0' )
  {
    a++; b = *a; 
    if ( isgraph(b) ) { b = '\0'; }
  }

  return a;
}

void doprocof ( char *rg_a )
{
  char *a;
  char b;

  char *c;
  long d;


  a = rg_a;
  b = *a;
  a++;

  if ( b == '-' )
  {
    printf("%s\n",a);
    return;
  }

  if ( b == '$' )
  {
    fflush(stdout);
    system(a);
  }

  if ( b == '%' )
  {
    chosys(a);
  }

  if ( b == '*' )
  {
    printf("%s",a);
    return;
  }

  if ( b == 'e' )
  {
    c = getenv(a);
    if ( c != ((char *)NULL) ) { printf("%s",c); }
    return;
  }

  if ( b == 's' )
  {
    d = atol(a);
    while ( d > ((long)0) )
    {
      putchar(' ');
      d--;
    }
    return;
  }


  /* ****
  I added the following directive so as to more easily
  have tabs in makefiles.
  **** */
  if ( b == 't' )
  {
    d = atol(a);
    while ( d > ((long)0) )
    {
      putchar(((char)9));
      d--;
    }
    return;
  }
}

void intopt ( char *rg_a )
{
  char *a;
  char b;

  a = rg_a;
  b = *a;
  a++;

  if ( b == '/' )
  {
    doprocof(a);
    return;
  }
}

int samestrg ( char *rg_a, char *rg_b )
{
  char *a;
  char *b;

  if ( rg_a == rg_b ) return 10;
  if ( rg_a == NULL ) return 0;
  if ( rg_b == NULL ) return 0;
  a = rg_a;
  b = rg_b;
  while ( *a == *b )
  {
    if ( *a == '\0' ) return 10;
    a++;
    b++;
  }
  return 0;
}

void chosys ( char *rg_a )
{
  FILE *a;
  char b;
  char c;

  a = popen(rg_a,"r");
  if ( a == ((FILE *)NULL) ) { return; }

  b = fgetc(a);
  if ( !feof(a) ) { c = fgetc(a); }
  while ( !feof(a) )
  {
    putchar(b);

    b = c; c = fgetc(a);
  }

  pclose(a);
}








