
# ########################################################################
# install.pl - by Adam Shapira
# Copyright (C) 2001 Techno-Info Comprehensive Solutions
#
# This software is licensed under the terms of the GNU General Public
# License version 2.0 of the Free Software Foundation (http://www.gnu.org)
# with NO WARRANTY, even the implied waranty of merchantability, or
# usability for a particular purpose.
#
# To contact the author of this program, visit the software web-site
# at:  http://boxenv.com
# ########################################################################

sub chopext {
  my $lc_arg;
  my $lc_ext;
  my $lc_cre;

  $lc_arg = $_[0];
  $lc_ext = "";

  $_[1] = $lc_arg;
  $_[2] = $lc_ext;

  while ( $lc_arg ne "" )
  {
    $lc_cre = chop($lc_arg);
    if ( $lc_cre eq "/" ) { return; }
    if ( $lc_cre eq "." )
    {
      $_[1] = $lc_arg;
      $_[2] = $lc_ext;
    }
    $lc_ext = "$lc_cre$lc_ext";
  }
}

sub chopnom {
  my $lc_arg;
  my $lc_ext;
  my $lc_cre;

  $lc_arg = $_[0];
  $lc_ext = "";

  $_[1] = $lc_arg;
  $_[2] = $lc_ext;

  while ( $lc_arg ne "" )
  {
    $lc_cre = chop($lc_arg);
    if ( $lc_cre eq "/" )
    {
      $_[1] = $lc_arg;
      $_[2] = $lc_ext;
      return;
    }
    $lc_ext = "$lc_cre$lc_ext";
  }
}

sub justilib_h {
  my $lc_arg;
  my $lc_cool;

  foreach $lc_arg (@_)
  {
    $lc_cool = "$packagedir/install-headers/$lc_arg";
    system("rm","-rf","$lc_cool.h");
    system("cat $lc_cool/*.h > $lc_cool.h");
    @liblorn = (@liblorn,"$lc_cool.h");
  }
}
@liblorn = ();

sub dodize {
  my $lc_arg;

  foreach $lc_arg (@_)
  {
    system("cp $lc_arg.pl-yes $lc_arg.pl-no");
  }
}

#&dodize("early-res/comp-package");
#&dodize("early-res/lib-install");


# END OF FUNCTIONS:



$packagea = "box-3";
$packagedir = `pwd`; chop($packagedir);
$homedir = $ENV{"HOME"};
$ENV{"PACKAGE_LOCATION"} = $packagedir;
$krfprg = "perl $packagedir/early-res/krefslc3.pln";

$err_file = `$krfprg \"\${BX3PREF}\" install-error-file`; chop($err_file);
if ( $err_file eq "" ) { $err_file = "/dev/null"; }
$err_put = "otpt $err_file \`date +%Y-%m%d-%T\`:";

$cmplr = `$krfprg \"\${BX3PREF}\" c-compiler`; chop($cmplr);
if ( $cmplr eq "" )
{
  $bxp = $ENV{"BX3PREF"};
  $dth = "FATAL ERROR: Pref Variable Not Found:";
  $dth = "$dth\n  Pref File: $bxp:";
  $dth = "$dth\n   Pref Var: c-compiler:";
  $dth = "$dth\n    Meaning: What C Compiler to Use:";
  die "\n$dth\n\n";
}

#$ostp = $ENV{"OSTkYPE"};
$ostp = `perl $packagedir/early-res/bx3-ostype.pln os`; chop($ostp);

$tmp = `$krfprg $packagedir/os-info/feature.prf3 $ostp-sharedlib`; chop($tmp);
$shared_lib = "no";
if ( $tmp eq "yes" ) { $shared_lib = "yes"; }

if ( $shared_lib eq "no" )
{
  system("echo",
    "WARNING: System \"$ostp\" Unknown to be Capable of SharedLibs:");
  $shared_lib = "yes";
}

system("echo Processing of SharedLib File: $shared_lib");

if ( $shared_lib eq "no" )
{
  die "FATAL ERROR: System \"$ostp\" Unknown to be Capable of SharedLibs:\n";
}

&justilib_h("ufcstrg1");
&justilib_h("ufccgi1");
&justilib_h("ufclib1");
&justilib_h("ufclib2");

$gc = "$cmplr -I$packagedir/install-headers";

$zano = "0";
if ( $homedir ne "" ) { $zano = chdir("$homedir"); }
# $zano will be "0" if failiure and 1 if successful.

if ( $zano < 0.5 )
{
  die "FATAL ERROR: Could Not Enter Home Directory:\n";
}

system("rm -f env-stat");
system("perl $packagedir/env-check.pl env-stat");
$env_stat = `cat env-stat`; chop($env_stat);
system("rm -f env-stat");
if ( $env_stat ne "yes" )
{
  die "Installation Aborted due to Insufficient Environment:\n";
}

$zano = chdir("$packagedir");
if ( $zano < 0.5 )
{
  die "FATAL ERROR: Could Not Return to Package Directory:\n";
}

$osbx = $ENV{"OS_BX_TkYPE"};
$osbx = `perl $packagedir/early-res/bx3-ostype.pln os dash cpu`; chop($osbx);
system("echo Our OS is: $osbx");

$zimta = `find .`;
@zimtb = split(/\n/,$zimta);


system("cp c-src/isexist.c isexist.c");
system("$gc -o isexist.tll isexist.c");
system("rm isexist.c");


system("mkdir $packagea-$osbx");

foreach $zimtc (@zimtb)
{
  $ftyp = `./isexist.tll $zimtc`; chop($ftyp);
  if ( $ftyp eq "DIRECTORY" )
  {
    system("mkdir -p $packagea-$osbx/$zimtc");
  }
}

foreach $zimtc (@zimtb)
{
  $ftyp = `./isexist.tll $zimtc`; chop($ftyp);
  if ( $ftyp eq "FILE" )
  {
    $okwas = "no";
    &chopext($zimtc,$zimtd,$zimte);
    &chopnom($zimtc,$zimtf,$zimtg);

    system("$err_put Processing File: $zimtc");

    if ( $okwas eq "no" ) { if ( $zimtg eq "Makefile" ) {
      system("cp $zimtc $packagea-$osbx/$zimtc");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "cst" ) {
      system("cp $zimtc $packagea-$osbx/$zimtc");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "prf3" ) {
      system("cp $zimtc $packagea-$osbx/$zimtc");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "qpl" ) {
      system("cp $zimtc $packagea-$osbx/$zimtc");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "pln" ) {
      system("cp $zimtc $packagea-$osbx/$zimtd.pl");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "pl-$shared_lib" ) {
      system("cp $zimtc $packagea-$osbx/$zimtd.pl");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "ptx" ) {
      system("cool-language-l < $zimtc > $packagea-$osbx/$zimtd.html");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "c" ) {
      system("cp $zimtc $packagea-$osbx/$zimtd.c");
      system("$gc -c -o $packagea-$osbx/$zimtd.o $packagea-$osbx/$zimtd.c");
      system("rm $packagea-$osbx/$zimtd.c");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "lb-c" ) {
      system("cp $zimtc $packagea-$osbx/$zimtd.c");
      $tm_comd = "$gc";
      if ( $shared_lib eq "yes" ) { $tm_comd = "$tm_comd -fPIC"; }
      $tm_comd = "$tm_comd -Wall -c -o";
      $tm_comd = "$tm_comd $packagea-$osbx/$zimtd.o";
      $tm_comd = "$tm_comd $packagea-$osbx/$zimtd.c";
      system("$tm_comd");
      system("rm $packagea-$osbx/$zimtd.c");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "h" ) {
      system("cp $zimtc $packagea-$osbx/$zimtc");
      $okwas = "yes";
    } }

    if ( $okwas eq "no" ) { if ( $zimte eq "gif" ) {
      system("cp $zimtc $packagea-$osbx/$zimtc");
      $okwas = "yes";
    } }

    if ( $zimte eq "pl" ) { $okwas = "yes"; }

    if ( $zimte eq "pl-yes" ) { $okwas = "yes"; }
    if ( $zimte eq "pl-no" ) { $okwas = "yes"; }

    if ( $okwas eq "no" )
    {
      system("$err_put \"    \"Strange Extention: $zimte");
      #print "$zimtc - $zimtd - $zimte -\n";
    }
  }
}

system("rm -rf $packagea-$osbx/clib-headers");
system("cp -r install-headers $packagea-$osbx/clib-headers");

system("echo $osbx > $packagea-$osbx/os-info/os-bx-type");
system("echo $ostp > $packagea-$osbx/os-info/os-type");
system("echo $shared_lib > $packagea-$osbx/os-info/shared-lib");
system("rm -r $packagea-$osbx/ticss-inhouse-res");

#$cmdon = "cp early-res/lib-install.pl-$shared_lib";
$cmdon = "$cmdon $packagea-$osbx/early-res/lib-install.pl";
system($cmdon);

system("echo Creating Tar Archive");
system("tar cf $packagea-$osbx.tar $packagea-$osbx");
system("echo Tar Archive Created");
system("mv $packagea-$osbx.tar ..");
system("perl go-for-it.pl $packagea-$osbx");
system("rm -rf $packagea-$osbx");


system("rm isexist.tll");
foreach $liblors (@liblorn)
{
  system("rm","-rf",$liblors);
}





