/* ****
lota.c
Copyright (C) 1998  Ultra-Flamin' Cool Computer Consulting
Copyright (C) 2001 Techno-Info Comprehensive Solutions

This software is licensed under the terms of the GNU General Public
License version 2.0 of the Free Software Foundation (http://www.gnu.org)
with NO WARRANTY, even the implied waranty of merchantability, or
usability for a particular purpose.

To contact the author of this program, visit the software web-site
at:  http://boxenv.com
**** */

#include <stdio.h>
#include <ufcstrg1/dupstrg.h>
#include <ufclib1/lota.h>

#define BITSIN_LONG ( sizeof(long) * 8 )

static char *loc_a (); /* long */
static char *loc_b (); /* long */

/* Return value: ASCII-string representation of number, or NULL */
/* in the event that the function has failed for some odd reason: */
char *lota(a)
long a; /* The number (in the form of a long integer): */
{
  char *b;
  if ( a < (long)0 ) b = loc_a(a);
  else b = loc_b(a);
  return b;
}

static char *loc_a(a)
long a;
{
  char b[BITSIN_LONG];
  int c;
  long d, e, f;
  char *g;
  c = BITSIN_LONG;
  c--;
  b[c] = '\0';
  d = a;
  while ( d < (long)0 )
  {
    e = ( d % (long)10 );
    c--;
    b[c] = ( '0' + (char)(-e) );
    f = ( d - e );
    d = ( f / (long)(10) );
  }
  if ( b[c] == '\0' ) { c--; b[c] = '0'; }
  else { c--; b[c] = '-'; }
  g = dupstrg(b+c);
  return g;
}

static char *loc_b(a)
long a;
{
  char b[BITSIN_LONG];
  int c;
  long d, e, f;
  char *g;
  c = BITSIN_LONG;
  c--;
  b[c] = '\0';
  d = a;
  while ( d > (long)0 )
  {
    e = ( d % (long)10 );
    c--;
    b[c] = ( '0' + (char)(e) );
    f = ( d - e );
    d = ( f / (long)(10) );
  }
  if ( b[c] == '\0' ) { c--; b[c] = '0'; }
  g = dupstrg(b+c);
  return g;
}



